#if !defined(__xped4app_h)              // Sentry, use file only if it's not already included.
#define __xped4app_h

/*  Project xped4
    
    Copyright  1993. All Rights Reserved.

    SUBSYSTEM:    xped4.exe Application
    FILE:         xped4app.h
    AUTHOR:       


    OVERVIEW
    ========
    Class definition for XpEd4App (TApplication).      
*/


#include <owl\owlpch.h>
#pragma hdrstop

#include <owl\printer.h>

#include <classlib\bags.h>


#include "xped4app.rh"            // Definition of all resources.


// TFileDrop class Maintains information about a dropped file, its name, where it was dropped,
// and whether or not it was in the client area
class TFileDrop {
public:
    operator == (const TFileDrop& other) const {return this == &other;}

    char*   FileName;
    TPoint  Point;
    BOOL    InClientArea;

    HICON   Icon;
    BOOL    DefIcon;

    TFileDrop (char*, TPoint&, BOOL, TModule* module);
    ~TFileDrop ();

    const char* WhoAmI ();
private:
    //
    // hidden to prevent accidental copying or assignment
    //
    TFileDrop (const TFileDrop&);
    TFileDrop & operator = (const TFileDrop&);
};

typedef TIBagAsVector<TFileDrop> TFileList;
typedef TIBagAsVectorIterator<TFileDrop> TFileListIter;


//{{TApplication = XpEd4App}}
class XpEd4App : public TApplication {
private:

private:
    void AddFiles (TFileList* files);

public:
    XpEd4App ();
    virtual ~XpEd4App ();

    // Public data members used by the print menu commands and Paint routine in MDIChild.
    TPrinter        *Printer;                           // Printer support.
    BOOL            Printing;                           // Printing in progress.

//{{XpEd4AppVIRTUAL_BEGIN}}
public:
    virtual void InitMainWindow();
    virtual void InitInstance();
//{{XpEd4AppVIRTUAL_END}}
//{{XpEd4AppRSP_TBL_BEGIN}}
protected:
    void CmHelpAbout ();
    void EvDropFiles (TDropInfo drop);
    void EvWinIniChange (char far* section);
//{{XpEd4AppRSP_TBL_END}}
DECLARE_RESPONSE_TABLE(XpEd4App);
};    //{{XpEd4App}}


#endif                                      // __xped4app_h sentry.
